#!/bin/bash

function cleanup()
{
	echo ""
}

function check_ret()
{
	ret=$1
	if [ "$ret" -ne 0 ]; then
		echo "Validation of last command failed, ret(${ret})"
		exit $ret
	fi

}

function error_on_zero()
{
	ret=$1
	if [ "$ret" -eq 0 ]; then
		echo "Validation of last command failed, ret(${ret})"
		exit $ret
	fi

}

function exec_cmd()
{
	echo "executing $@"
	$@ >/dev/null 2>&1

	if [ $? -ne 0 ]; then
		echo "Failed to execute $@"
		exit 1
	fi
}

function make_clean()
{
	make clean
	rm *.gcno
	rm *.gcda
}

function make_build()
{
	export CFLAGS="-g -O0 -fprofile-arcs -ftest-coverage"
	export LDFLAGS="--coverage"
	exec_cmd make
}

function make_install_lib()
{
	mkdir -p /usr/lib/bbfdm/
	exec_cmd cp libxmppc.so /usr/lib/bbfdm/
}

